#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/iofunc.h>
#include <sys/dispatch.h>
#include <iostream.h>
#include <process.h>
#include "comand.h"
#include "agefun.h"
//---------------------------------------------------------------------------------------------------------------------------
int main( int argc, char **argv ) {
    char devstr[  PATH_MAX + 1 ] = "/dev/";
    strcat( devstr, strrchr( argv[ 0 ], '/' ) != NULL ? strrchr( argv[ 0 ], '/' ) + 1 : argv[ 0 ] );
    // проверить наличие копии - 2 экземпляра не запускать!
    int fd = open( devstr, O_RDONLY );
    if( fd > 0 ) cout << devstr << " alrady load." << endl, exit( EXIT_FAILURE );
    close( fd );
    // порождающий процесс на этом завершается
    if( fork() != 0 ) return EXIT_SUCCESS; 
    // старт однопотокового менеджера в порождённом процессе
    dispatch_t *dpp;
    if( ( dpp = dispatch_create() ) == NULL )
       cout << "unable to allocate dispatch handle." << endl, exit( EXIT_FAILURE );
    resmgr_attr_t resmgr_attr;
    //инициализация аттрибутов ресурс менеджера
    memset( &resmgr_attr, 0, sizeof resmgr_attr );
    resmgr_attr.nparts_max = 1;
    resmgr_attr.msg_max_size = 2048;
    // статически определённые таблицы функций подсоединения и обмена
    static resmgr_connect_funcs_t    connect_funcs;
    static resmgr_io_funcs_t              io_funcs;
    iofunc_func_init( _RESMGR_CONNECT_NFUNCS, &connect_funcs, _RESMGR_IO_NFUNCS, &io_funcs );
    // прописываем свои функции в таблицы операций 
    io_funcs.read = &read;
    io_funcs.write = &write;    
    io_funcs.devctl = &devctl;
    // инициализация структуры аттрибутов, используемых устройством
    static iofunc_attr_t attr;    
    iofunc_attr_init( &attr, S_IFNAM | 0666, 0, 0 );
    // присоединить имя устройства
    int  id = resmgr_attach(  dpp,                            // dispatch handle              
                                            &resmgr_attr,             // resource manager attrs 
                                            devstr,                      // device name                  
                                            _FTYPE_ANY,                // open type                      
                                            0,                                 // flags                               
                                            &connect_funcs,          // connect routines           
                                            &io_funcs,                    // I/O routines                    
                                            &attr );                         // handle                            
    if( id == -1 ) cout << "unable to attach name." << endl, exit( EXIT_FAILURE ); 
    // разместить структуру контекста
    dispatch_context_t  *ctp = dispatch_context_alloc( dpp );
    // старт бескоречного цикла, его завершение может быть 
    // обеспечено только извне командами kill или slay
    while( true ) {
        if( ( ctp = dispatch_block( ctp ) ) == NULL ) cout << "block error." << endl, exit( EXIT_FAILURE );
        dispatch_handler( ctp );
    }
};

