#include "coder.h"
//------------------------------------------------------------------------------------------------------------
int main( int argc, char *argv[] ) {
    cout << "Single Decoder, " << VERS << endl;
    if( argc != 3 ) cout << "wrong arguments number." << endl, exit( EXIT_FAILURE );
    // 1-й параметр - файл для декодирования, 2-й параметр - длина ключа
    int fds = open( argv[ 1 ], O_RDONLY ),
         keylen = atoi( argv[ 2 ] );
    if( keylen <= 0 ) cout << "wrong key length: " << argv[ 2 ] << endl, exit( EXIT_FAILURE );
    if( fds < 0 ) cout << "input file not found: " << argv[ 1 ] << endl, exit( EXIT_FAILURE );
    struct stat buf;
    // определяется длина исходного файла и он целиком считывается в буфер 
    if( fstat( fds , &buf ) < 0 ) perror( "fstat error" ), exit( EXIT_FAILURE );
    unsigned long slen = buf.st_size;
    char *inp = new char[ slen ]; 
    if( read( fds, inp, slen ) != slen ) perror( "read error" ), exit( EXIT_FAILURE );
    close( fds ); 
    key bkey( keylen ), ckey( keylen );
    unsigned long long n = 0;
    cout << "find:";
    while( ckey.next() != bkey ) {
       // кодируется входная последовательность новым ключём
       char *out = ckey.code( inp, slen );
       // проверяется на принадлежность строки "печатным" символам
       if( test( out, slen ) ) {
           cout << "\t" << ckey;
           n++;
           if( n % KEY_OUT_INLINE == 0 ) cout << endl;
        }
        delete out;
    };
    if( n % KEY_OUT_INLINE != 0 ) cout << endl;
    cout << "find " << n << " keys" << endl;
    exit( EXIT_SUCCESS );
};
//------------------------------------------------------------------------------------------------------------

